/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * AMF3GPPAccessRegistrationDocumentApi.h
 *
 *
 */

#ifndef AMF3GPPAccessRegistrationDocumentApi_H_
#define AMF3GPPAccessRegistrationDocumentApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "Amf3GppAccessRegistration.h"
#include "PatchItem.h"
#include "PatchResult.h"
#include "ProblemDetails.h"
#include <string>
#include <vector>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class AMF3GPPAccessRegistrationDocumentApi {
public:
  AMF3GPPAccessRegistrationDocumentApi(std::shared_ptr<Pistache::Rest::Router>);
  virtual ~AMF3GPPAccessRegistrationDocumentApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void amf_context3gpp_handler(const Pistache::Rest::Request &request,
                               Pistache::Http::ResponseWriter response);
  void create_amf_context3gpp_handler(const Pistache::Rest::Request &request,
                                      Pistache::Http::ResponseWriter response);
  void query_amf_context3gpp_handler(const Pistache::Rest::Request &request,
                                     Pistache::Http::ResponseWriter response);
  void amf3_gpp_access_registration_document_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// To modify the AMF context data of a UE using 3gpp access in the UDR
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE id</param>
  /// <param name="patchItem"></param>
  /// <param name="supportedFeatures">Features required to be supported by the
  /// target NF (optional, default to &quot;&quot;)</param>
  virtual void
  amf_context3gpp(const std::string &ueId,
                  const std::vector<PatchItem> &patchItem,
                  const Pistache::Optional<std::string> &supportedFeatures,
                  Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// To store the AMF context data of a UE using 3gpp access in the UDR
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE id</param>
  /// <param name="amf3GppAccessRegistration"> (optional)</param>
  virtual void
  create_amf_context3gpp(const std::string &ueId,
                         Amf3GppAccessRegistration &amf3GppAccessRegistration,
                         Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Retrieves the AMF context data of a UE using 3gpp access
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE id</param>
  /// <param name="fields">attributes to be retrieved (optional, default to
  /// std::vector&lt;std::string&gt;())</param> <param
  /// name="supportedFeatures">Supported Features (optional, default to
  /// &quot;&quot;)</param>
  virtual void query_amf_context3gpp(
      const std::string &ueId,
      const Pistache::Optional<std::vector<std::string>> &fields,
      const Pistache::Optional<std::string> &supportedFeatures,
      Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* AMF3GPPAccessRegistrationDocumentApi_H_ */
