/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * ApplicationDataSubscriptionsCollectionApi.h
 *
 *
 */

#ifndef ApplicationDataSubscriptionsCollectionApi_H_
#define ApplicationDataSubscriptionsCollectionApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "ApplicationDataSubs.h"
#include "DataFilter.h"
#include "ProblemDetails.h"

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class ApplicationDataSubscriptionsCollectionApi {
public:
  ApplicationDataSubscriptionsCollectionApi(
      std::shared_ptr<Pistache::Rest::Router>);
  virtual ~ApplicationDataSubscriptionsCollectionApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void create_individual_application_data_subscription_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void read_application_data_change_subscriptions_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void application_data_subscriptions_collection_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Create a subscription to receive notification of application data changes
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="applicationDataSubs"></param>
  virtual void create_individual_application_data_subscription(
      const ApplicationDataSubs &applicationDataSubs,
      Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Read Application Data change Subscriptions
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="dataFilter">The data filter for the query. (optional, default
  /// to DataFilter())</param>
  virtual void read_application_data_change_subscriptions(
      const Pistache::Optional<DataFilter> &dataFilter,
      Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* ApplicationDataSubscriptionsCollectionApi_H_ */
