/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * BdtDataStoreApi.h
 *
 *
 */

#ifndef BdtDataStoreApi_H_
#define BdtDataStoreApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "BdtData.h"
#include "ProblemDetails.h"
#include <string>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class BdtDataStoreApi {
public:
  BdtDataStoreApi(std::shared_ptr<Pistache::Rest::Router>);
  virtual ~BdtDataStoreApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void read_bdt_data_handler(const Pistache::Rest::Request &request,
                             Pistache::Http::ResponseWriter response);
  void
  bdt_data_store_api_default_handler(const Pistache::Rest::Request &request,
                                     Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Retrieves the BDT data collection
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="bdtRefIds">List of the BDT reference identifiers. (optional,
  /// default to std::vector&lt;std::string&gt;())</param> <param
  /// name="suppFeat">Supported Features (optional, default to
  /// &quot;&quot;)</param>
  virtual void
  read_bdt_data(const Pistache::Optional<std::vector<std::string>> &bdtRefIds,
                const Pistache::Optional<std::string> &suppFeat,
                Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* BdtDataStoreApi_H_ */
