/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "ContextDataDocumentApi.h"
#include "Helpers.h"

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::helpers;
using namespace org::openapitools::server::model;

ContextDataDocumentApi::ContextDataDocumentApi(
    std::shared_ptr<Pistache::Rest::Router> rtr) {
  router = rtr;
}

void ContextDataDocumentApi::init() { setupRoutes(); }

void ContextDataDocumentApi::setupRoutes() {
  using namespace Pistache::Rest;

  Routes::Get(
      *router, base + "/subscription-data/:ueId/context-data",
      Routes::bind(&ContextDataDocumentApi::query_context_data_handler, this));

  // Default handler, called when a route is not found
  router->addCustomHandler(Routes::bind(
      &ContextDataDocumentApi::context_data_document_api_default_handler,
      this));
}

void ContextDataDocumentApi::query_context_data_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto ueId = request.param(":ueId").as<std::string>();

  // Getting the query params
  auto contextDatasetNamesQuery = request.query().get("context-dataset-names");
  Pistache::Optional<std::vector<ContextDataSetName>> contextDatasetNames;
  if (!contextDatasetNamesQuery.isEmpty()) {
    //        std::vector<ContextDataSetName> valueQuery_instance;
    //        if(fromStringValue(contextDatasetNamesQuery.get(),
    //        valueQuery_instance)){
    //            contextDatasetNames = Pistache::Some(valueQuery_instance);
    //        }
  }

  try {
    //      this->query_context_data(ueId, contextDatasetNames, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}

void ContextDataDocumentApi::context_data_document_api_default_handler(
    const Pistache::Rest::Request &, Pistache::Http::ResponseWriter response) {
  response.send(Pistache::Http::Code::Not_Found,
                "The requested method does not exist");
}

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org
