/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * EventExposureGroupSubscriptionDocumentApi.h
 *
 *
 */

#ifndef EventExposureGroupSubscriptionDocumentApi_H_
#define EventExposureGroupSubscriptionDocumentApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "EeSubscription.h"
//#include "Object.h"
#include "PatchItem.h"
#include "PatchResult.h"
#include "ProblemDetails.h"
#include <string>
#include <vector>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class EventExposureGroupSubscriptionDocumentApi {
public:
  EventExposureGroupSubscriptionDocumentApi(
      std::shared_ptr<Pistache::Rest::Router>);
  virtual ~EventExposureGroupSubscriptionDocumentApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void
  modify_ee_group_subscription_handler(const Pistache::Rest::Request &request,
                                       Pistache::Http::ResponseWriter response);
  void
  query_ee_group_subscription_handler(const Pistache::Rest::Request &request,
                                      Pistache::Http::ResponseWriter response);
  void remove_ee_group_subscriptions_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void update_ee_group_subscriptions_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void event_exposure_group_subscription_document_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Modify an individual ee subscription for a group of a UEs
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueGroupId"></param>
  /// <param name="subsId"></param>
  /// <param name="patchItem"></param>
  /// <param name="supportedFeatures">Features required to be supported by the
  /// target NF (optional, default to &quot;&quot;)</param>
  virtual void modify_ee_group_subscription(
      const std::string &ueGroupId, const std::string &subsId,
      const std::vector<PatchItem> &patchItem,
      const Pistache::Optional<std::string> &supportedFeatures,
      Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Retrieve a individual eeSubscription for a group of UEs or any UE
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueGroupId"></param>
  /// <param name="subsId">Unique ID of the subscription to remove</param>
  virtual void
  query_ee_group_subscription(const std::string &ueGroupId,
                              const std::string &subsId,
                              Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Deletes a eeSubscription for a group of UEs or any UE
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueGroupId"></param>
  /// <param name="subsId">Unique ID of the subscription to remove</param>
  virtual void
  remove_ee_group_subscriptions(const std::string &ueGroupId,
                                const std::string &subsId,
                                Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Update an individual ee subscription of a group of UEs or any UE
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueGroupId"></param>
  /// <param name="subsId"></param>
  /// <param name="eeSubscription"> (optional)</param>
  virtual void
  update_ee_group_subscriptions(const std::string &ueGroupId,
                                const std::string &subsId,
                                const EeSubscription &eeSubscription,
                                Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* EventExposureGroupSubscriptionDocumentApi_H_ */
