/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * EventExposureSubscriptionsCollectionApi.h
 *
 *
 */

#ifndef EventExposureSubscriptionsCollectionApi_H_
#define EventExposureSubscriptionsCollectionApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "EeSubscription.h"
#include <string>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class EventExposureSubscriptionsCollectionApi {
public:
  EventExposureSubscriptionsCollectionApi(
      std::shared_ptr<Pistache::Rest::Router>);
  virtual ~EventExposureSubscriptionsCollectionApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void create_ee_subscriptions_handler(const Pistache::Rest::Request &request,
                                       Pistache::Http::ResponseWriter response);
  void queryeesubscriptions_handler(const Pistache::Rest::Request &request,
                                    Pistache::Http::ResponseWriter response);
  void event_exposure_subscriptions_collection_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Create individual EE subscription
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE ID</param>
  /// <param name="eeSubscription"></param>
  virtual void
  create_ee_subscriptions(const std::string &ueId,
                          const EeSubscription &eeSubscription,
                          Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Retrieves the ee subscriptions of a UE
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE id</param>
  /// <param name="supportedFeatures">Supported Features (optional, default to
  /// &quot;&quot;)</param>
  virtual void
  queryeesubscriptions(const std::string &ueId,
                       const Pistache::Optional<std::string> &supportedFeatures,
                       Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* EventExposureSubscriptionsCollectionApi_H_ */
