/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * IPSMGWRegistrationDocumentApi.h
 *
 *
 */

#ifndef IPSMGWRegistrationDocumentApi_H_
#define IPSMGWRegistrationDocumentApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "IpSmGwRegistration.h"
#include "PatchItem.h"
#include "ProblemDetails.h"
#include <string>
#include <vector>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class IPSMGWRegistrationDocumentApi {
public:
  IPSMGWRegistrationDocumentApi(std::shared_ptr<Pistache::Rest::Router>);
  virtual ~IPSMGWRegistrationDocumentApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void create_ip_sm_gw_context_handler(const Pistache::Rest::Request &request,
                                       Pistache::Http::ResponseWriter response);
  void delete_ip_sm_gw_context_handler(const Pistache::Rest::Request &request,
                                       Pistache::Http::ResponseWriter response);
  void modify_ip_sm_gw_context_handler(const Pistache::Rest::Request &request,
                                       Pistache::Http::ResponseWriter response);
  void query_ip_sm_gw_context_handler(const Pistache::Rest::Request &request,
                                      Pistache::Http::ResponseWriter response);
  void ipsmgw_registration_document_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Create the IP-SM-GW context data of a UE
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE id</param>
  /// <param name="ipSmGwRegistration"> (optional)</param>
  virtual void
  create_ip_sm_gw_context(const std::string &ueId,
                          const IpSmGwRegistration &ipSmGwRegistration,
                          Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// To remove the IP-SM-GW context data of a UE
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE id</param>
  virtual void
  delete_ip_sm_gw_context(const std::string &ueId,
                          Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Modify the IP-SM-GW context data of a UE
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE id</param>
  /// <param name="patchItem"></param>
  virtual void
  modify_ip_sm_gw_context(const std::string &ueId,
                          const std::vector<PatchItem> &patchItem,
                          Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Retrieves the IP-SM-GW context data of a UE
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE id</param>
  /// <param name="fields">attributes to be retrieved (optional, default to
  /// std::vector&lt;std::string&gt;())</param> <param
  /// name="supportedFeatures">Supported Features (optional, default to
  /// &quot;&quot;)</param>
  virtual void query_ip_sm_gw_context(
      const std::string &ueId,
      const Pistache::Optional<std::vector<std::string>> &fields,
      const Pistache::Optional<std::string> &supportedFeatures,
      Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* IPSMGWRegistrationDocumentApi_H_ */
