/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * IndividualApplicationDataSubscriptionDocumentApi.h
 *
 *
 */

#ifndef IndividualApplicationDataSubscriptionDocumentApi_H_
#define IndividualApplicationDataSubscriptionDocumentApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "ApplicationDataSubs.h"
#include "ProblemDetails.h"
#include <string>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class IndividualApplicationDataSubscriptionDocumentApi {
public:
  IndividualApplicationDataSubscriptionDocumentApi(
      std::shared_ptr<Pistache::Rest::Router>);
  virtual ~IndividualApplicationDataSubscriptionDocumentApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void delete_individual_application_data_subscription_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void read_individual_application_data_subscription_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void replace_individual_application_data_subscription_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void individual_application_data_subscription_document_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Delete the individual Application Data subscription
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="subsId"></param>
  virtual void delete_individual_application_data_subscription(
      const std::string &subsId, Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Get an existing individual Application Data Subscription resource
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="subsId">String identifying a subscription to the Individual
  /// Application Data Subscription</param>
  virtual void read_individual_application_data_subscription(
      const std::string &subsId, Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Modify a subscription to receive notification of application data changes
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="subsId"></param>
  /// <param name="applicationDataSubs"></param>
  virtual void replace_individual_application_data_subscription(
      const std::string &subsId, const ApplicationDataSubs &applicationDataSubs,
      Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* IndividualApplicationDataSubscriptionDocumentApi_H_ */
