/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "IndividualBDTPolicyDataDocumentApi.h"
#include "Helpers.h"

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::helpers;
using namespace org::openapitools::server::model;

IndividualBDTPolicyDataDocumentApi::IndividualBDTPolicyDataDocumentApi(
    std::shared_ptr<Pistache::Rest::Router> rtr) {
  router = rtr;
}

void IndividualBDTPolicyDataDocumentApi::init() { setupRoutes(); }

void IndividualBDTPolicyDataDocumentApi::setupRoutes() {
  using namespace Pistache::Rest;

  Routes::Put(
      *router, base + "/application-data/bdtPolicyData/:bdtPolicyId",
      Routes::bind(&IndividualBDTPolicyDataDocumentApi::
                       create_individual_applied_bdt_policy_data_handler,
                   this));

  // Default handler, called when a route is not found
  router->addCustomHandler(
      Routes::bind(&IndividualBDTPolicyDataDocumentApi::
                       individual_bdt_policy_data_document_api_default_handler,
                   this));
}

void IndividualBDTPolicyDataDocumentApi::
    create_individual_applied_bdt_policy_data_handler(
        const Pistache::Rest::Request &request,
        Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto bdtPolicyId = request.param(":bdtPolicyId").as<std::string>();

  // Getting the body param

  BdtPolicyData bdtPolicyData;

  try {
    nlohmann::json::parse(request.body()).get_to(bdtPolicyData);
    this->create_individual_applied_bdt_policy_data(bdtPolicyId, bdtPolicyData,
                                                    response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}

void IndividualBDTPolicyDataDocumentApi::
    individual_bdt_policy_data_document_api_default_handler(
        const Pistache::Rest::Request &,
        Pistache::Http::ResponseWriter response) {
  response.send(Pistache::Http::Code::Not_Found,
                "The requested method does not exist");
}

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org
