/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "IndividualBdtDataDocumentApi.h"
#include "Helpers.h"

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::helpers;
using namespace org::openapitools::server::model;

IndividualBdtDataDocumentApi::IndividualBdtDataDocumentApi(
    std::shared_ptr<Pistache::Rest::Router> rtr) {
  router = rtr;
}

void IndividualBdtDataDocumentApi::init() { setupRoutes(); }

void IndividualBdtDataDocumentApi::setupRoutes() {
  using namespace Pistache::Rest;

  Routes::Put(
      *router, base + "/policy-data/bdt-data/:bdtReferenceId",
      Routes::bind(
          &IndividualBdtDataDocumentApi::create_individual_bdt_data_handler,
          this));
  Routes::Delete(
      *router, base + "/policy-data/bdt-data/:bdtReferenceId",
      Routes::bind(
          &IndividualBdtDataDocumentApi::delete_individual_bdt_data_handler,
          this));
  Routes::Get(
      *router, base + "/policy-data/bdt-data/:bdtReferenceId",
      Routes::bind(
          &IndividualBdtDataDocumentApi::read_individual_bdt_data_handler,
          this));
  Routes::Patch(
      *router, base + "/policy-data/bdt-data/:bdtReferenceId",
      Routes::bind(
          &IndividualBdtDataDocumentApi::update_individual_bdt_data_handler,
          this));

  // Default handler, called when a route is not found
  router->addCustomHandler(
      Routes::bind(&IndividualBdtDataDocumentApi::
                       individual_bdt_data_document_api_default_handler,
                   this));
}

void IndividualBdtDataDocumentApi::create_individual_bdt_data_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto bdtReferenceId = request.param(":bdtReferenceId").as<std::string>();

  // Getting the body param

  BdtData bdtData;

  try {
    nlohmann::json::parse(request.body()).get_to(bdtData);
    this->create_individual_bdt_data(bdtReferenceId, bdtData, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}
void IndividualBdtDataDocumentApi::delete_individual_bdt_data_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto bdtReferenceId = request.param(":bdtReferenceId").as<std::string>();

  try {
    this->delete_individual_bdt_data(bdtReferenceId, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}
void IndividualBdtDataDocumentApi::read_individual_bdt_data_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto bdtReferenceId = request.param(":bdtReferenceId").as<std::string>();

  // Getting the query params
  auto suppFeatQuery = request.query().get("supp-feat");
  Pistache::Optional<std::string> suppFeat;
  if (!suppFeatQuery.isEmpty()) {
    std::string valueQuery_instance;
    if (fromStringValue(suppFeatQuery.get(), valueQuery_instance)) {
      suppFeat = Pistache::Some(valueQuery_instance);
    }
  }

  try {
    this->read_individual_bdt_data(bdtReferenceId, suppFeat, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}
void IndividualBdtDataDocumentApi::update_individual_bdt_data_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto bdtReferenceId = request.param(":bdtReferenceId").as<std::string>();

  // Getting the body param

  BdtDataPatch bdtDataPatch;

  try {
    nlohmann::json::parse(request.body()).get_to(bdtDataPatch);
    this->update_individual_bdt_data(bdtReferenceId, bdtDataPatch, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}

void IndividualBdtDataDocumentApi::
    individual_bdt_data_document_api_default_handler(
        const Pistache::Rest::Request &,
        Pistache::Http::ResponseWriter response) {
  response.send(Pistache::Http::Code::Not_Found,
                "The requested method does not exist");
}

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org
