/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * IndividualExposureDataSubscriptionDocumentApi.h
 *
 *
 */

#ifndef IndividualExposureDataSubscriptionDocumentApi_H_
#define IndividualExposureDataSubscriptionDocumentApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "ExposureDataSubscription.h"
#include "ProblemDetails.h"
#include <string>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class IndividualExposureDataSubscriptionDocumentApi {
public:
  IndividualExposureDataSubscriptionDocumentApi(
      std::shared_ptr<Pistache::Rest::Router>);
  virtual ~IndividualExposureDataSubscriptionDocumentApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void delete_individual_exposure_data_subscription_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void replace_individual_exposure_data_subscription_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void individual_exposure_data_subscription_document_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Deletes the individual Exposure Data subscription
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="subId">Subscription id</param>
  virtual void delete_individual_exposure_data_subscription(
      const std::string &subId, Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// updates a subscription to receive notifications of exposure data changes
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="subId">Subscription id</param>
  /// <param name="exposureDataSubscription"></param>
  virtual void replace_individual_exposure_data_subscription(
      const std::string &subId,
      const ExposureDataSubscription &exposureDataSubscription,
      Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* IndividualExposureDataSubscriptionDocumentApi_H_ */
