/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * IndividualIPTVConfigurationDataApi.h
 *
 *
 */

#ifndef IndividualIPTVConfigurationDataApi_H_
#define IndividualIPTVConfigurationDataApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "IptvConfigData.h"
#include "IptvConfigDataPatch.h"
#include "ProblemDetails.h"
#include <string>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class IndividualIPTVConfigurationDataApi {
public:
  IndividualIPTVConfigurationDataApi(std::shared_ptr<Pistache::Rest::Router>);
  virtual ~IndividualIPTVConfigurationDataApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void partial_replace_individual_iptv_configuration_data_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void individual_iptv_configuration_data_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Partial update an individual IPTV configuration resource
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="configurationId">The Identifier of an Individual IPTV
  /// Configuration Data to be updated. It shall apply the format of Data type
  /// string.</param> <param name="iptvConfigDataPatch"></param>
  virtual void partial_replace_individual_iptv_configuration_data(
      const std::string &configurationId,
      const IptvConfigDataPatch &iptvConfigDataPatch,
      Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* IndividualIPTVConfigurationDataApi_H_ */
