/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "IndividualIPTVConfigurationDataDocumentApi.h"
#include "Helpers.h"

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::helpers;
using namespace org::openapitools::server::model;

IndividualIPTVConfigurationDataDocumentApi::
    IndividualIPTVConfigurationDataDocumentApi(
        std::shared_ptr<Pistache::Rest::Router> rtr) {
  router = rtr;
}

void IndividualIPTVConfigurationDataDocumentApi::init() { setupRoutes(); }

void IndividualIPTVConfigurationDataDocumentApi::setupRoutes() {
  using namespace Pistache::Rest;

  Routes::Put(
      *router, base + "/application-data/iptvConfigData/:configurationId",
      Routes::bind(
          &IndividualIPTVConfigurationDataDocumentApi::
              create_or_replace_individual_iptv_configuration_data_handler,
          this));
  Routes::Delete(
      *router, base + "/application-data/iptvConfigData/:configurationId",
      Routes::bind(&IndividualIPTVConfigurationDataDocumentApi::
                       delete_individual_iptv_configuration_data_handler,
                   this));

  // Default handler, called when a route is not found
  router->addCustomHandler(Routes::bind(
      &IndividualIPTVConfigurationDataDocumentApi::
          individual_iptv_configuration_data_document_api_default_handler,
      this));
}

void IndividualIPTVConfigurationDataDocumentApi::
    create_or_replace_individual_iptv_configuration_data_handler(
        const Pistache::Rest::Request &request,
        Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto configurationId = request.param(":configurationId").as<std::string>();

  // Getting the body param

  IptvConfigData iptvConfigData;

  try {
    nlohmann::json::parse(request.body()).get_to(iptvConfigData);
    this->create_or_replace_individual_iptv_configuration_data(
        configurationId, iptvConfigData, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}
void IndividualIPTVConfigurationDataDocumentApi::
    delete_individual_iptv_configuration_data_handler(
        const Pistache::Rest::Request &request,
        Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto configurationId = request.param(":configurationId").as<std::string>();

  try {
    this->delete_individual_iptv_configuration_data(configurationId, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}

void IndividualIPTVConfigurationDataDocumentApi::
    individual_iptv_configuration_data_document_api_default_handler(
        const Pistache::Rest::Request &,
        Pistache::Http::ResponseWriter response) {
  response.send(Pistache::Http::Code::Not_Found,
                "The requested method does not exist");
}

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org
