/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * IndividualInfluenceDataDocumentApi.h
 *
 *
 */

#ifndef IndividualInfluenceDataDocumentApi_H_
#define IndividualInfluenceDataDocumentApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "ProblemDetails.h"
#include "TrafficInfluData.h"
#include "TrafficInfluDataPatch.h"
#include <string>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class IndividualInfluenceDataDocumentApi {
public:
  IndividualInfluenceDataDocumentApi(std::shared_ptr<Pistache::Rest::Router>);
  virtual ~IndividualInfluenceDataDocumentApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void create_or_replace_individual_influence_data_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void delete_individual_influence_data_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void update_individual_influence_data_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void individual_influence_data_document_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Create or update an individual Influence Data resource
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="influenceId">The Identifier of an Individual Influence Data
  /// to be created or updated. It shall apply the format of Data type
  /// string.</param> <param name="trafficInfluData"></param>
  virtual void create_or_replace_individual_influence_data(
      const std::string &influenceId, const TrafficInfluData &trafficInfluData,
      Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Delete an individual Influence Data resource
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="influenceId">The Identifier of an Individual Influence Data
  /// to be updated. It shall apply the format of Data type string.</param>
  virtual void delete_individual_influence_data(
      const std::string &influenceId,
      Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Modify part of the properties of an individual Influence Data resource
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="influenceId">The Identifier of an Individual Influence Data
  /// to be updated. It shall apply the format of Data type string.</param>
  /// <param name="trafficInfluDataPatch"></param>
  virtual void update_individual_influence_data(
      const std::string &influenceId,
      const TrafficInfluDataPatch &trafficInfluDataPatch,
      Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* IndividualInfluenceDataDocumentApi_H_ */
