/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * IndividualInfluenceDataSubscriptionDocumentApi.h
 *
 *
 */

#ifndef IndividualInfluenceDataSubscriptionDocumentApi_H_
#define IndividualInfluenceDataSubscriptionDocumentApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "ProblemDetails.h"
#include "TrafficInfluSub.h"
#include <string>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class IndividualInfluenceDataSubscriptionDocumentApi {
public:
  IndividualInfluenceDataSubscriptionDocumentApi(
      std::shared_ptr<Pistache::Rest::Router>);
  virtual ~IndividualInfluenceDataSubscriptionDocumentApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void delete_individual_influence_data_subscription_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void read_individual_influence_data_subscription_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void replace_individual_influence_data_subscription_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void individual_influence_data_subscription_document_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Delete an individual Influence Data Subscription resource
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="subscriptionId">String identifying a subscription to the
  /// Individual Influence Data Subscription</param>
  virtual void delete_individual_influence_data_subscription(
      const std::string &subscriptionId,
      Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Get an existing individual Influence Data Subscription resource
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="subscriptionId">String identifying a subscription to the
  /// Individual Influence Data Subscription</param>
  virtual void read_individual_influence_data_subscription(
      const std::string &subscriptionId,
      Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Modify an existing individual Influence Data Subscription resource
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="subscriptionId">String identifying a subscription to the
  /// Individual Influence Data Subscription</param> <param
  /// name="trafficInfluSub"></param>
  virtual void replace_individual_influence_data_subscription(
      const std::string &subscriptionId, const TrafficInfluSub &trafficInfluSub,
      Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* IndividualInfluenceDataSubscriptionDocumentApi_H_ */
