/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "IndividualPFDDataDocumentApi.h"
#include "Helpers.h"

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::helpers;
using namespace org::openapitools::server::model;

IndividualPFDDataDocumentApi::IndividualPFDDataDocumentApi(
    std::shared_ptr<Pistache::Rest::Router> rtr) {
  router = rtr;
}

void IndividualPFDDataDocumentApi::init() { setupRoutes(); }

void IndividualPFDDataDocumentApi::setupRoutes() {
  using namespace Pistache::Rest;

  Routes::Put(*router, base + "/application-data/pfds/:appId",
              Routes::bind(&IndividualPFDDataDocumentApi::
                               create_or_replace_individual_pfd_data_handler,
                           this));
  Routes::Delete(
      *router, base + "/application-data/pfds/:appId",
      Routes::bind(
          &IndividualPFDDataDocumentApi::delete_individual_pfd_data_handler,
          this));
  Routes::Get(
      *router, base + "/application-data/pfds/:appId",
      Routes::bind(
          &IndividualPFDDataDocumentApi::read_individual_pfd_data_handler,
          this));

  // Default handler, called when a route is not found
  router->addCustomHandler(
      Routes::bind(&IndividualPFDDataDocumentApi::
                       individual_pfd_data_document_api_default_handler,
                   this));
}

void IndividualPFDDataDocumentApi::
    create_or_replace_individual_pfd_data_handler(
        const Pistache::Rest::Request &request,
        Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto appId = request.param(":appId").as<std::string>();

  // Getting the body param

  PfdDataForAppExt pfdDataForAppExt;

  try {
    nlohmann::json::parse(request.body()).get_to(pfdDataForAppExt);
    this->create_or_replace_individual_pfd_data(appId, pfdDataForAppExt,
                                                response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}
void IndividualPFDDataDocumentApi::delete_individual_pfd_data_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto appId = request.param(":appId").as<std::string>();

  try {
    this->delete_individual_pfd_data(appId, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}
void IndividualPFDDataDocumentApi::read_individual_pfd_data_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto appId = request.param(":appId").as<std::string>();

  try {
    this->read_individual_pfd_data(appId, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}

void IndividualPFDDataDocumentApi::
    individual_pfd_data_document_api_default_handler(
        const Pistache::Rest::Request &,
        Pistache::Http::ResponseWriter response) {
  response.send(Pistache::Http::Code::Not_Found,
                "The requested method does not exist");
}

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org
