/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * IndividualPFDDataDocumentApi.h
 *
 *
 */

#ifndef IndividualPFDDataDocumentApi_H_
#define IndividualPFDDataDocumentApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "PfdDataForAppExt.h"
#include "ProblemDetails.h"
#include <string>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class IndividualPFDDataDocumentApi {
public:
  IndividualPFDDataDocumentApi(std::shared_ptr<Pistache::Rest::Router>);
  virtual ~IndividualPFDDataDocumentApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void create_or_replace_individual_pfd_data_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void
  delete_individual_pfd_data_handler(const Pistache::Rest::Request &request,
                                     Pistache::Http::ResponseWriter response);
  void
  read_individual_pfd_data_handler(const Pistache::Rest::Request &request,
                                   Pistache::Http::ResponseWriter response);
  void individual_pfd_data_document_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Create or update the corresponding PFDs for the specified application
  /// identifier
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="appId">Indicate the application identifier for the request
  /// pfd(s). It shall apply the format of Data type ApplicationId.</param>
  /// <param name="pfdDataForAppExt"></param>
  virtual void create_or_replace_individual_pfd_data(
      const std::string &appId, const PfdDataForAppExt &pfdDataForAppExt,
      Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Delete the corresponding PFDs of the specified application identifier
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="appId">Indicate the application identifier for the request
  /// pfd(s). It shall apply the format of Data type ApplicationId.</param>
  virtual void
  delete_individual_pfd_data(const std::string &appId,
                             Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Retrieve the corresponding PFDs of the specified application identifier
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="appId">Indicate the application identifier for the request
  /// pfd(s). It shall apply the format of Data type ApplicationId.</param>
  virtual void
  read_individual_pfd_data(const std::string &appId,
                           Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* IndividualPFDDataDocumentApi_H_ */
