/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "IndividualPolicyDataSubscriptionDocumentApi.h"
#include "Helpers.h"

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::helpers;
using namespace org::openapitools::server::model;

IndividualPolicyDataSubscriptionDocumentApi::
    IndividualPolicyDataSubscriptionDocumentApi(
        std::shared_ptr<Pistache::Rest::Router> rtr) {
  router = rtr;
}

void IndividualPolicyDataSubscriptionDocumentApi::init() { setupRoutes(); }

void IndividualPolicyDataSubscriptionDocumentApi::setupRoutes() {
  using namespace Pistache::Rest;

  Routes::Delete(
      *router, base + "/policy-data/subs-to-notify/:subsId",
      Routes::bind(&IndividualPolicyDataSubscriptionDocumentApi::
                       delete_individual_policy_data_subscription_handler,
                   this));
  Routes::Put(
      *router, base + "/policy-data/subs-to-notify/:subsId",
      Routes::bind(&IndividualPolicyDataSubscriptionDocumentApi::
                       replace_individual_policy_data_subscription_handler,
                   this));

  // Default handler, called when a route is not found
  router->addCustomHandler(Routes::bind(
      &IndividualPolicyDataSubscriptionDocumentApi::
          individual_policy_data_subscription_document_api_default_handler,
      this));
}

void IndividualPolicyDataSubscriptionDocumentApi::
    delete_individual_policy_data_subscription_handler(
        const Pistache::Rest::Request &request,
        Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto subsId = request.param(":subsId").as<std::string>();

  try {
    this->delete_individual_policy_data_subscription(subsId, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}
void IndividualPolicyDataSubscriptionDocumentApi::
    replace_individual_policy_data_subscription_handler(
        const Pistache::Rest::Request &request,
        Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto subsId = request.param(":subsId").as<std::string>();

  // Getting the body param

  PolicyDataSubscription policyDataSubscription;

  try {
    nlohmann::json::parse(request.body()).get_to(policyDataSubscription);
    this->replace_individual_policy_data_subscription(
        subsId, policyDataSubscription, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}

void IndividualPolicyDataSubscriptionDocumentApi::
    individual_policy_data_subscription_document_api_default_handler(
        const Pistache::Rest::Request &,
        Pistache::Http::ResponseWriter response) {
  response.send(Pistache::Http::Code::Not_Found,
                "The requested method does not exist");
}

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org
