/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * IndividualPolicyDataSubscriptionDocumentApi.h
 *
 *
 */

#ifndef IndividualPolicyDataSubscriptionDocumentApi_H_
#define IndividualPolicyDataSubscriptionDocumentApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "PolicyDataSubscription.h"
#include "ProblemDetails.h"
#include <string>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class IndividualPolicyDataSubscriptionDocumentApi {
public:
  IndividualPolicyDataSubscriptionDocumentApi(
      std::shared_ptr<Pistache::Rest::Router>);
  virtual ~IndividualPolicyDataSubscriptionDocumentApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void delete_individual_policy_data_subscription_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void replace_individual_policy_data_subscription_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void individual_policy_data_subscription_document_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Delete the individual Policy Data subscription
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="subsId"></param>
  virtual void delete_individual_policy_data_subscription(
      const std::string &subsId, Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Modify a subscription to receive notification of policy data changes
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="subsId"></param>
  /// <param name="policyDataSubscription"></param>
  virtual void replace_individual_policy_data_subscription(
      const std::string &subsId,
      const PolicyDataSubscription &policyDataSubscription,
      Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* IndividualPolicyDataSubscriptionDocumentApi_H_ */
