/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * MessageWaitingDataDocumentApi.h
 *
 *
 */

#ifndef MessageWaitingDataDocumentApi_H_
#define MessageWaitingDataDocumentApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "MessageWaitingData.h"
#include "PatchItem.h"
#include "ProblemDetails.h"
#include <string>
#include <vector>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class MessageWaitingDataDocumentApi {
public:
  MessageWaitingDataDocumentApi(std::shared_ptr<Pistache::Rest::Router>);
  virtual ~MessageWaitingDataDocumentApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void
  create_message_waiting_data_handler(const Pistache::Rest::Request &request,
                                      Pistache::Http::ResponseWriter response);
  void
  delete_message_waiting_data_handler(const Pistache::Rest::Request &request,
                                      Pistache::Http::ResponseWriter response);
  void
  modify_message_waiting_data_handler(const Pistache::Rest::Request &request,
                                      Pistache::Http::ResponseWriter response);
  void
  query_message_waiting_data_handler(const Pistache::Rest::Request &request,
                                     Pistache::Http::ResponseWriter response);
  void message_waiting_data_document_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Create the Message Waiting Data of the UE
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE id</param>
  /// <param name="messageWaitingData"> (optional)</param>
  virtual void
  create_message_waiting_data(const std::string &ueId,
                              const MessageWaitingData &messageWaitingData,
                              Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// To remove the Message Waiting Data of the UE
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE id</param>
  virtual void
  delete_message_waiting_data(const std::string &ueId,
                              Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Modify the Message Waiting Data of the UE
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE id</param>
  /// <param name="patchItem"></param>
  virtual void
  modify_message_waiting_data(const std::string &ueId,
                              const std::vector<PatchItem> &patchItem,
                              Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Retrieves the Message Waiting Data of the UE
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE id</param>
  /// <param name="fields">attributes to be retrieved (optional, default to
  /// std::vector&lt;std::string&gt;())</param> <param
  /// name="supportedFeatures">Supported Features (optional, default to
  /// &quot;&quot;)</param>
  virtual void query_message_waiting_data(
      const std::string &ueId,
      const Pistache::Optional<std::vector<std::string>> &fields,
      const Pistache::Optional<std::string> &supportedFeatures,
      Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* MessageWaitingDataDocumentApi_H_ */
