/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * OperatorSpecificDataDocumentApi.h
 *
 *
 */

#ifndef OperatorSpecificDataDocumentApi_H_
#define OperatorSpecificDataDocumentApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "OperatorSpecificDataContainer.h"
#include "PatchItem.h"
#include "PatchResult.h"
#include "ProblemDetails.h"
#include <map>
#include <string>
#include <vector>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class OperatorSpecificDataDocumentApi {
public:
  OperatorSpecificDataDocumentApi(std::shared_ptr<Pistache::Rest::Router>);
  virtual ~OperatorSpecificDataDocumentApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void
  read_operator_specific_data_handler(const Pistache::Rest::Request &request,
                                      Pistache::Http::ResponseWriter response);
  void replace_operator_specific_data_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void update_operator_specific_data_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void operator_specific_data_document_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Retrieve the operator specific policy data of an UE
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE Id</param>
  /// <param name="fields">attributes to be retrieved (optional, default to
  /// std::vector&lt;std::string&gt;())</param> <param name="suppFeat">Supported
  /// Features (optional, default to &quot;&quot;)</param>
  virtual void read_operator_specific_data(
      const std::string &ueId,
      const Pistache::Optional<std::vector<std::string>> &fields,
      const Pistache::Optional<std::string> &suppFeat,
      Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Modify the operator specific policy data of an UE
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE Id</param>
  /// <param name="requestBody"></param>
  virtual void replace_operator_specific_data(
      const std::string &ueId,
      const std::map<std::string, OperatorSpecificDataContainer> &requestBody,
      Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Modify the operator specific policy data of an UE
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE Id</param>
  /// <param name="patchItem"></param>
  virtual void
  update_operator_specific_data(const std::string &ueId,
                                const std::vector<PatchItem> &patchItem,
                                Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* OperatorSpecificDataDocumentApi_H_ */
