/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "PFDDataStoreApi.h"
#include "Helpers.h"

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::helpers;
using namespace org::openapitools::server::model;

PFDDataStoreApi::PFDDataStoreApi(std::shared_ptr<Pistache::Rest::Router> rtr) {
  router = rtr;
}

void PFDDataStoreApi::init() { setupRoutes(); }

void PFDDataStoreApi::setupRoutes() {
  using namespace Pistache::Rest;

  Routes::Get(*router, base + "/application-data/pfds",
              Routes::bind(&PFDDataStoreApi::read_pfd_data_handler, this));

  // Default handler, called when a route is not found
  router->addCustomHandler(
      Routes::bind(&PFDDataStoreApi::pfd_data_store_api_default_handler, this));
}

void PFDDataStoreApi::read_pfd_data_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {

  // Getting the query params
  auto appIdQuery = request.query().get("appId");
  Pistache::Optional<std::vector<std::string>> appId;
  if (!appIdQuery.isEmpty()) {
    std::vector<std::string> valueQuery_instance;
    if (fromStringValue(appIdQuery.get(), valueQuery_instance)) {
      appId = Pistache::Some(valueQuery_instance);
    }
  }

  try {
    this->read_pfd_data(appId, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}

void PFDDataStoreApi::pfd_data_store_api_default_handler(
    const Pistache::Rest::Request &, Pistache::Http::ResponseWriter response) {
  response.send(Pistache::Http::Code::Not_Found,
                "The requested method does not exist");
}

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org
