/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * PFDDataStoreApi.h
 *
 *
 */

#ifndef PFDDataStoreApi_H_
#define PFDDataStoreApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "PfdDataForAppExt.h"
#include "ProblemDetails.h"
#include <string>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class PFDDataStoreApi {
public:
  PFDDataStoreApi(std::shared_ptr<Pistache::Rest::Router>);
  virtual ~PFDDataStoreApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void read_pfd_data_handler(const Pistache::Rest::Request &request,
                             Pistache::Http::ResponseWriter response);
  void
  pfd_data_store_api_default_handler(const Pistache::Rest::Request &request,
                                     Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Retrieve PFDs for application identifier(s)
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="appId">Contains the information of the application
  /// identifier(s) for the querying PFD Data resource. If none appId is
  /// included in the URI, it applies to all application identifier(s) for the
  /// querying PFD Data resource. (optional, default to
  /// std::vector&lt;std::string&gt;())</param>
  virtual void
  read_pfd_data(const Pistache::Optional<std::vector<std::string>> &appId,
                Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* PFDDataStoreApi_H_ */
