/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "QueryIdentityDataBySUPIOrGPSIDocumentApi.h"
#include "Helpers.h"

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::helpers;
using namespace org::openapitools::server::model;

QueryIdentityDataBySUPIOrGPSIDocumentApi::
    QueryIdentityDataBySUPIOrGPSIDocumentApi(
        std::shared_ptr<Pistache::Rest::Router> rtr) {
  router = rtr;
}

void QueryIdentityDataBySUPIOrGPSIDocumentApi::init() { setupRoutes(); }

void QueryIdentityDataBySUPIOrGPSIDocumentApi::setupRoutes() {
  using namespace Pistache::Rest;

  Routes::Get(
      *router, base + "/subscription-data/:ueId/identity-data",
      Routes::bind(
          &QueryIdentityDataBySUPIOrGPSIDocumentApi::get_identity_data_handler,
          this));

  // Default handler, called when a route is not found
  router->addCustomHandler(Routes::bind(
      &QueryIdentityDataBySUPIOrGPSIDocumentApi::
          query_identity_data_by_supi_or_gpsi_document_api_default_handler,
      this));
}

void QueryIdentityDataBySUPIOrGPSIDocumentApi::get_identity_data_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto ueId = request.param(":ueId").as<std::string>();

  // Getting the query params
  auto appPortIdQuery = request.query().get("app-port-id");
  Pistache::Optional<AppPortId> appPortId;
  if (!appPortIdQuery.isEmpty()) {
    //        AppPortId valueQuery_instance;
    //        if(fromStringValue(appPortIdQuery.get(), valueQuery_instance)){
    //            appPortId = Pistache::Some(valueQuery_instance);
    //        }
  }

  // Getting the header params
  auto ifNoneMatch = request.headers().tryGetRaw("If-None-Match");
  auto ifModifiedSince = request.headers().tryGetRaw("If-Modified-Since");

  try {
    this->get_identity_data(ueId, appPortId, ifNoneMatch, ifModifiedSince,
                            response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}

void QueryIdentityDataBySUPIOrGPSIDocumentApi::
    query_identity_data_by_supi_or_gpsi_document_api_default_handler(
        const Pistache::Rest::Request &,
        Pistache::Http::ResponseWriter response) {
  response.send(Pistache::Http::Code::Not_Found,
                "The requested method does not exist");
}

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org
