/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * QueryIdentityDataBySUPIOrGPSIDocumentApi.h
 *
 *
 */

#ifndef QueryIdentityDataBySUPIOrGPSIDocumentApi_H_
#define QueryIdentityDataBySUPIOrGPSIDocumentApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "AppPortId.h"
#include "IdentityData.h"
#include <string>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class QueryIdentityDataBySUPIOrGPSIDocumentApi {
public:
  QueryIdentityDataBySUPIOrGPSIDocumentApi(
      std::shared_ptr<Pistache::Rest::Router>);
  virtual ~QueryIdentityDataBySUPIOrGPSIDocumentApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void get_identity_data_handler(const Pistache::Rest::Request &request,
                                 Pistache::Http::ResponseWriter response);
  void query_identity_data_by_supi_or_gpsi_document_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Retrieve identity data by SUPI or GPSI
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE ID</param>
  /// <param name="appPortId">Application port identifier (optional, default to
  /// AppPortId())</param> <param name="ifNoneMatch">Validator for conditional
  /// requests, as described in RFC 7232, 3.2 (optional, default to
  /// &quot;&quot;)</param> <param name="ifModifiedSince">Validator for
  /// conditional requests, as described in RFC 7232, 3.3 (optional, default to
  /// &quot;&quot;)</param>
  virtual void get_identity_data(
      const std::string &ueId, const Pistache::Optional<AppPortId> &appPortId,
      const Pistache::Optional<Pistache::Http::Header::Raw> &ifNoneMatch,
      const Pistache::Optional<Pistache::Http::Header::Raw> &ifModifiedSince,
      Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* QueryIdentityDataBySUPIOrGPSIDocumentApi_H_ */
