/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "SDMSubscriptionDocumentApi.h"
#include "Helpers.h"

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::helpers;
using namespace org::openapitools::server::model;

SDMSubscriptionDocumentApi::SDMSubscriptionDocumentApi(
    std::shared_ptr<Pistache::Rest::Router> rtr) {
  router = rtr;
}

void SDMSubscriptionDocumentApi::init() { setupRoutes(); }

void SDMSubscriptionDocumentApi::setupRoutes() {
  using namespace Pistache::Rest;

  Routes::Patch(
      *router,
      base + "/subscription-data/:ueId/context-data/sdm-subscriptions/:subsId",
      Routes::bind(&SDMSubscriptionDocumentApi::modifysdm_subscription_handler,
                   this));
  Routes::Get(
      *router,
      base + "/subscription-data/:ueId/context-data/sdm-subscriptions/:subsId",
      Routes::bind(&SDMSubscriptionDocumentApi::querysdm_subscription_handler,
                   this));
  Routes::Delete(
      *router,
      base + "/subscription-data/:ueId/context-data/sdm-subscriptions/:subsId",
      Routes::bind(&SDMSubscriptionDocumentApi::removesdm_subscriptions_handler,
                   this));
  Routes::Put(
      *router,
      base + "/subscription-data/:ueId/context-data/sdm-subscriptions/:subsId",
      Routes::bind(&SDMSubscriptionDocumentApi::updatesdmsubscriptions_handler,
                   this));

  // Default handler, called when a route is not found
  router->addCustomHandler(
      Routes::bind(&SDMSubscriptionDocumentApi::
                       sdm_subscription_document_api_default_handler,
                   this));
}

void SDMSubscriptionDocumentApi::modifysdm_subscription_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto ueId = request.param(":ueId").as<std::string>();
  auto subsId = request.param(":subsId").as<std::string>();

  // Getting the body param
  std::vector<PatchItem> patchItem;

  // Getting the query params
  auto supportedFeaturesQuery = request.query().get("supported-features");
  Pistache::Optional<std::string> supportedFeatures;
  if (!supportedFeaturesQuery.isEmpty()) {
    std::string valueQuery_instance;
    if (fromStringValue(supportedFeaturesQuery.get(), valueQuery_instance)) {
      supportedFeatures = Pistache::Some(valueQuery_instance);
    }
  }

  try {
    nlohmann::json::parse(request.body()).get_to(patchItem);
    this->modifysdm_subscription(ueId, subsId, patchItem, supportedFeatures,
                                 response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}
void SDMSubscriptionDocumentApi::querysdm_subscription_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto ueId = request.param(":ueId").as<std::string>();
  auto subsId = request.param(":subsId").as<std::string>();

  try {
    this->querysdm_subscription(ueId, subsId, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}
void SDMSubscriptionDocumentApi::removesdm_subscriptions_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto ueId = request.param(":ueId").as<std::string>();
  auto subsId = request.param(":subsId").as<std::string>();

  try {
    this->removesdm_subscriptions(ueId, subsId, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}
void SDMSubscriptionDocumentApi::updatesdmsubscriptions_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto ueId = request.param(":ueId").as<std::string>();
  auto subsId = request.param(":subsId").as<std::string>();

  // Getting the body param

  SdmSubscription sdmSubscription;

  try {
    nlohmann::json::parse(request.body()).get_to(sdmSubscription);
    this->updatesdmsubscriptions(ueId, subsId, sdmSubscription, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}

void SDMSubscriptionDocumentApi::sdm_subscription_document_api_default_handler(
    const Pistache::Rest::Request &, Pistache::Http::ResponseWriter response) {
  response.send(Pistache::Http::Code::Not_Found,
                "The requested method does not exist");
}

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org
