/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * SMSF3GPPRegistrationDocumentApi.h
 *
 *
 */

#ifndef SMSF3GPPRegistrationDocumentApi_H_
#define SMSF3GPPRegistrationDocumentApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

#include "SmsfRegistration.h"
#include <string>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class SMSF3GPPRegistrationDocumentApi {
public:
  SMSF3GPPRegistrationDocumentApi(std::shared_ptr<Pistache::Rest::Router>);
  virtual ~SMSF3GPPRegistrationDocumentApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void create_smsf_context3gpp_handler(const Pistache::Rest::Request &request,
                                       Pistache::Http::ResponseWriter response);
  void delete_smsf_context3gpp_handler(const Pistache::Rest::Request &request,
                                       Pistache::Http::ResponseWriter response);
  void query_smsf_context3gpp_handler(const Pistache::Rest::Request &request,
                                      Pistache::Http::ResponseWriter response);
  void smsf3_gpp_registration_document_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Create the SMSF context data of a UE via 3GPP access
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE id</param>
  /// <param name="smsfRegistration"> (optional)</param>
  virtual void
  create_smsf_context3gpp(const std::string &ueId,
                          const SmsfRegistration &smsfRegistration,
                          Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// To remove the SMSF context data of a UE via 3GPP access
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE id</param>
  virtual void
  delete_smsf_context3gpp(const std::string &ueId,
                          Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Retrieves the SMSF context data of a UE using 3gpp access
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="ueId">UE id</param>
  /// <param name="fields">attributes to be retrieved (optional, default to
  /// std::vector&lt;std::string&gt;())</param> <param
  /// name="supportedFeatures">Supported Features (optional, default to
  /// &quot;&quot;)</param>
  virtual void query_smsf_context3gpp(
      const std::string &ueId,
      const Pistache::Optional<std::vector<std::string>> &fields,
      const Pistache::Optional<std::string> &supportedFeatures,
      Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* SMSF3GPPRegistrationDocumentApi_H_ */
