/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "SubsToNotifyDocumentApi.h"
#include "Helpers.h"

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::helpers;
using namespace org::openapitools::server::model;

SubsToNotifyDocumentApi::SubsToNotifyDocumentApi(
    std::shared_ptr<Pistache::Rest::Router> rtr) {
  router = rtr;
}

void SubsToNotifyDocumentApi::init() { setupRoutes(); }

void SubsToNotifyDocumentApi::setupRoutes() {
  using namespace Pistache::Rest;

  Routes::Patch(*router, base + "/subscription-data/subs-to-notify/:subsId",
                Routes::bind(&SubsToNotifyDocumentApi::
                                 modifysubscription_data_subscription_handler,
                             this));
  Routes::Get(*router, base + "/subscription-data/subs-to-notify/:subsId",
              Routes::bind(&SubsToNotifyDocumentApi::
                               query_subscription_data_subscriptions_handler,
                           this));
  Routes::Delete(*router, base + "/subscription-data/subs-to-notify/:subsId",
                 Routes::bind(&SubsToNotifyDocumentApi::
                                  removesubscription_data_subscriptions_handler,
                              this));

  // Default handler, called when a route is not found
  router->addCustomHandler(Routes::bind(
      &SubsToNotifyDocumentApi::subs_to_notify_document_api_default_handler,
      this));
}

void SubsToNotifyDocumentApi::modifysubscription_data_subscription_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto subsId = request.param(":subsId").as<std::string>();

  // Getting the body param
  std::vector<PatchItem> patchItem;

  // Getting the query params
  auto supportedFeaturesQuery = request.query().get("supported-features");
  Pistache::Optional<std::string> supportedFeatures;
  if (!supportedFeaturesQuery.isEmpty()) {
    std::string valueQuery_instance;
    if (fromStringValue(supportedFeaturesQuery.get(), valueQuery_instance)) {
      supportedFeatures = Pistache::Some(valueQuery_instance);
    }
  }

  try {
    nlohmann::json::parse(request.body()).get_to(patchItem);
    this->modifysubscription_data_subscription(subsId, patchItem,
                                               supportedFeatures, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}
void SubsToNotifyDocumentApi::query_subscription_data_subscriptions_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto subsId = request.param(":subsId").as<std::string>();

  try {
    this->query_subscription_data_subscriptions(subsId, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}
void SubsToNotifyDocumentApi::removesubscription_data_subscriptions_handler(
    const Pistache::Rest::Request &request,
    Pistache::Http::ResponseWriter response) {
  // Getting the path params
  auto subsId = request.param(":subsId").as<std::string>();

  try {
    this->removesubscription_data_subscriptions(subsId, response);
  } catch (nlohmann::detail::exception &e) {
    // send a 400 error
    response.send(Pistache::Http::Code::Bad_Request, e.what());
    return;
  } catch (Pistache::Http::HttpError &e) {
    response.send(static_cast<Pistache::Http::Code>(e.code()), e.what());
    return;
  } catch (std::exception &e) {
    // send a 500 error
    response.send(Pistache::Http::Code::Internal_Server_Error, e.what());
    return;
  }
}

void SubsToNotifyDocumentApi::subs_to_notify_document_api_default_handler(
    const Pistache::Rest::Request &, Pistache::Http::ResponseWriter response) {
  response.send(Pistache::Http::Code::Not_Found,
                "The requested method does not exist");
}

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org
