/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * SubsToNotifyDocumentApi.h
 *
 *
 */

#ifndef SubsToNotifyDocumentApi_H_
#define SubsToNotifyDocumentApi_H_

#include <pistache/http.h>
#include <pistache/http_headers.h>
#include <pistache/optional.h>
#include <pistache/router.h>

//#include "Object.h"
#include "PatchItem.h"
#include "PatchResult.h"
#include "ProblemDetails.h"
#include <string>
#include <vector>

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

class SubsToNotifyDocumentApi {
public:
  SubsToNotifyDocumentApi(std::shared_ptr<Pistache::Rest::Router>);
  virtual ~SubsToNotifyDocumentApi() {}
  void init();

  const std::string base = "/nudr-dr/v2";

private:
  void setupRoutes();

  void modifysubscription_data_subscription_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void query_subscription_data_subscriptions_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void removesubscription_data_subscriptions_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);
  void subs_to_notify_document_api_default_handler(
      const Pistache::Rest::Request &request,
      Pistache::Http::ResponseWriter response);

  std::shared_ptr<Pistache::Rest::Router> router;

  /// <summary>
  /// Modify an individual subscriptionDataSubscription
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="subsId"></param>
  /// <param name="patchItem"></param>
  /// <param name="supportedFeatures">Features required to be supported by the
  /// target NF (optional, default to &quot;&quot;)</param>
  virtual void modifysubscription_data_subscription(
      const std::string &subsId, const std::vector<PatchItem> &patchItem,
      const Pistache::Optional<std::string> &supportedFeatures,
      Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Retrieves a individual subscriptionDataSubscription identified by subsId
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="subsId">Unique ID of the subscription to retrieve</param>
  virtual void query_subscription_data_subscriptions(
      const std::string &subsId, Pistache::Http::ResponseWriter &response) = 0;

  /// <summary>
  /// Deletes a subscriptionDataSubscriptions
  /// </summary>
  /// <remarks>
  ///
  /// </remarks>
  /// <param name="subsId">Unique ID of the subscription to remove</param>
  virtual void removesubscription_data_subscriptions(
      const std::string &subsId, Pistache::Http::ResponseWriter &response) = 0;
};

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* SubsToNotifyDocumentApi_H_ */
