/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */

#include "SMFSelectionSubscriptionDataDocumentApiImpl.h"

namespace org {
namespace openapitools {
namespace server {
namespace api {

using namespace org::openapitools::server::model;

SMFSelectionSubscriptionDataDocumentApiImpl::
    SMFSelectionSubscriptionDataDocumentApiImpl(
        std::shared_ptr<Pistache::Rest::Router> rtr, MYSQL *mysql)
    : SMFSelectionSubscriptionDataDocumentApi(rtr) {
  mysql_WitcommUDRDB = mysql;
}

void SMFSelectionSubscriptionDataDocumentApiImpl::query_smf_select_data(
    const std::string &ueId, const std::string &servingPlmnId,
    const Pistache::Optional<std::vector<std::string>> &fields,
    const Pistache::Optional<std::string> &supportedFeatures,
    const Pistache::Optional<Pistache::Http::Header::Raw> &ifNoneMatch,
    const Pistache::Optional<Pistache::Http::Header::Raw> &ifModifiedSince,
    Pistache::Http::ResponseWriter &response) {
  MYSQL_RES *res = NULL;
  MYSQL_ROW row;
  MYSQL_FIELD *field = nullptr;

  nlohmann::json j;

  SmfSelectionSubscriptionData smfselectionsubscriptiondata;
  const std::string query =
      "select * from SmfSelectionSubscriptionData WHERE ueid=" + ueId +
      " and servingPlmnid=" + servingPlmnId;

  if (mysql_real_query(mysql_WitcommUDRDB, query.c_str(),
                       (unsigned long)query.size())) {
    std::cout << "mysql_real_query failure！" << std::endl;
    return;
  }

  res = mysql_store_result(mysql_WitcommUDRDB);
  if (res == NULL) {
    std::cout << "mysql_store_result failure！" << std::endl;
    return;
  }

  row = mysql_fetch_row(res);

  if (row != NULL) {
    for (int i = 0; field = mysql_fetch_field(res); i++) {
      if (!strcmp("supportedFeatures", field->name) && row[i] != NULL) {
        smfselectionsubscriptiondata.setSupportedFeatures(row[i]);
      } else if (!strcmp("subscribedSnssaiInfos", field->name) &&
                 row[i] != NULL) {
        std ::map<std ::string, SnssaiInfo> subscribedsnssaiinfos;
        nlohmann::json::parse(row[i]).get_to(subscribedsnssaiinfos);
        smfselectionsubscriptiondata.setSubscribedSnssaiInfos(
            subscribedsnssaiinfos);
      } else if (!strcmp("sharedSnssaiInfosId", field->name) &&
                 row[i] != NULL) {
        smfselectionsubscriptiondata.setSharedSnssaiInfosId(row[i]);
      }
    }
    to_json(j, smfselectionsubscriptiondata);
    response.send(Pistache::Http::Code::Ok, j.dump());
  } else {
    std::cout << "SmfSelectionSubscriptionData no data！" << std::endl;
  }

  mysql_free_result(res);
}

} // namespace api
} // namespace server
} // namespace openapitools
} // namespace org
