/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * AccessAndMobilityData.h
 *
 *
 */

#ifndef AccessAndMobilityData_H_
#define AccessAndMobilityData_H_

#include "AccessType.h"
#include "CmInfo.h"
#include "PlmnId.h"
#include "RatType.h"
#include "RmInfo.h"
#include "SmsSupport.h"
#include "UeReachability.h"
#include "UserLocation.h"
#include <nlohmann/json.hpp>
#include <string>
#include <vector>

namespace org {
namespace openapitools {
namespace server {
namespace model {

/// <summary>
///
/// </summary>
class AccessAndMobilityData {
public:
  AccessAndMobilityData();
  virtual ~AccessAndMobilityData();

  void validate();

  /////////////////////////////////////////////
  /// AccessAndMobilityData members

  /// <summary>
  ///
  /// </summary>
  UserLocation getLocation() const;
  void setLocation(UserLocation const &value);
  bool locationIsSet() const;
  void unsetLocation();
  /// <summary>
  ///
  /// </summary>
  std::string getLocationTs() const;
  void setLocationTs(std::string const &value);
  bool locationTsIsSet() const;
  void unsetLocationTs();
  /// <summary>
  ///
  /// </summary>
  std::string getTimeZone() const;
  void setTimeZone(std::string const &value);
  bool timeZoneIsSet() const;
  void unsetTimeZone();
  /// <summary>
  ///
  /// </summary>
  std::string getTimeZoneTs() const;
  void setTimeZoneTs(std::string const &value);
  bool timeZoneTsIsSet() const;
  void unsetTimeZoneTs();
  /// <summary>
  ///
  /// </summary>
  AccessType getAccessType() const;
  void setAccessType(AccessType const &value);
  bool accessTypeIsSet() const;
  void unsetAccessType();
  /// <summary>
  ///
  /// </summary>
  std::vector<RmInfo> &getRegStates();
  void setRegStates(std::vector<RmInfo> const &value);
  bool regStatesIsSet() const;
  void unsetRegStates();
  /// <summary>
  ///
  /// </summary>
  std::string getRegStatesTs() const;
  void setRegStatesTs(std::string const &value);
  bool regStatesTsIsSet() const;
  void unsetRegStatesTs();
  /// <summary>
  ///
  /// </summary>
  std::vector<CmInfo> &getConnStates();
  void setConnStates(std::vector<CmInfo> const &value);
  bool connStatesIsSet() const;
  void unsetConnStates();
  /// <summary>
  ///
  /// </summary>
  std::string getConnStatesTs() const;
  void setConnStatesTs(std::string const &value);
  bool connStatesTsIsSet() const;
  void unsetConnStatesTs();
  /// <summary>
  ///
  /// </summary>
  UeReachability getReachabilityStatus() const;
  void setReachabilityStatus(UeReachability const &value);
  bool reachabilityStatusIsSet() const;
  void unsetReachabilityStatus();
  /// <summary>
  ///
  /// </summary>
  std::string getReachabilityStatusTs() const;
  void setReachabilityStatusTs(std::string const &value);
  bool reachabilityStatusTsIsSet() const;
  void unsetReachabilityStatusTs();
  /// <summary>
  ///
  /// </summary>
  SmsSupport getSmsOverNasStatus() const;
  void setSmsOverNasStatus(SmsSupport const &value);
  bool smsOverNasStatusIsSet() const;
  void unsetSmsOverNasStatus();
  /// <summary>
  ///
  /// </summary>
  std::string getSmsOverNasStatusTs() const;
  void setSmsOverNasStatusTs(std::string const &value);
  bool smsOverNasStatusTsIsSet() const;
  void unsetSmsOverNasStatusTs();
  /// <summary>
  /// True  The serving PLMN of the UE is different from the HPLMN of the UE;
  /// False  The serving PLMN of the UE is the HPLMN of the UE.
  /// </summary>
  bool isRoamingStatus() const;
  void setRoamingStatus(bool const value);
  bool roamingStatusIsSet() const;
  void unsetRoamingStatus();
  /// <summary>
  ///
  /// </summary>
  std::string getRoamingStatusTs() const;
  void setRoamingStatusTs(std::string const &value);
  bool roamingStatusTsIsSet() const;
  void unsetRoamingStatusTs();
  /// <summary>
  ///
  /// </summary>
  PlmnId getCurrentPlmn() const;
  void setCurrentPlmn(PlmnId const &value);
  bool currentPlmnIsSet() const;
  void unsetCurrentPlmn();
  /// <summary>
  ///
  /// </summary>
  std::string getCurrentPlmnTs() const;
  void setCurrentPlmnTs(std::string const &value);
  bool currentPlmnTsIsSet() const;
  void unsetCurrentPlmnTs();
  /// <summary>
  ///
  /// </summary>
  std::vector<RatType> &getRatType();
  void setRatType(std::vector<RatType> const &value);
  bool ratTypeIsSet() const;
  void unsetRatType();
  /// <summary>
  ///
  /// </summary>
  std::string getRatTypesTs() const;
  void setRatTypesTs(std::string const &value);
  bool ratTypesTsIsSet() const;
  void unsetRatTypesTs();
  /// <summary>
  ///
  /// </summary>
  std::string getSuppFeat() const;
  void setSuppFeat(std::string const &value);
  bool suppFeatIsSet() const;
  void unsetSuppFeat();

  friend void to_json(nlohmann::json &j, const AccessAndMobilityData &o);
  friend void from_json(const nlohmann::json &j, AccessAndMobilityData &o);

protected:
  UserLocation m_Location;
  bool m_LocationIsSet;
  std::string m_LocationTs;
  bool m_LocationTsIsSet;
  std::string m_TimeZone;
  bool m_TimeZoneIsSet;
  std::string m_TimeZoneTs;
  bool m_TimeZoneTsIsSet;
  AccessType m_AccessType;
  bool m_AccessTypeIsSet;
  std::vector<RmInfo> m_RegStates;
  bool m_RegStatesIsSet;
  std::string m_RegStatesTs;
  bool m_RegStatesTsIsSet;
  std::vector<CmInfo> m_ConnStates;
  bool m_ConnStatesIsSet;
  std::string m_ConnStatesTs;
  bool m_ConnStatesTsIsSet;
  UeReachability m_ReachabilityStatus;
  bool m_ReachabilityStatusIsSet;
  std::string m_ReachabilityStatusTs;
  bool m_ReachabilityStatusTsIsSet;
  SmsSupport m_SmsOverNasStatus;
  bool m_SmsOverNasStatusIsSet;
  std::string m_SmsOverNasStatusTs;
  bool m_SmsOverNasStatusTsIsSet;
  bool m_RoamingStatus;
  bool m_RoamingStatusIsSet;
  std::string m_RoamingStatusTs;
  bool m_RoamingStatusTsIsSet;
  PlmnId m_CurrentPlmn;
  bool m_CurrentPlmnIsSet;
  std::string m_CurrentPlmnTs;
  bool m_CurrentPlmnTsIsSet;
  std::vector<RatType> m_RatType;
  bool m_RatTypeIsSet;
  std::string m_RatTypesTs;
  bool m_RatTypesTsIsSet;
  std::string m_SuppFeat;
  bool m_SuppFeatIsSet;
};

} // namespace model
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* AccessAndMobilityData_H_ */
