/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * PfdContent.h
 *
 *
 */

#ifndef PfdContent_H_
#define PfdContent_H_

#include "DomainNameProtocol.h"
#include <nlohmann/json.hpp>
#include <string>
#include <vector>

namespace org {
namespace openapitools {
namespace server {
namespace model {

/// <summary>
///
/// </summary>
class PfdContent {
public:
  PfdContent();
  virtual ~PfdContent();

  void validate();

  /////////////////////////////////////////////
  /// PfdContent members

  /// <summary>
  /// Identifies a PDF of an application identifier.
  /// </summary>
  std::string getPfdId() const;
  void setPfdId(std::string const &value);
  bool pfdIdIsSet() const;
  void unsetPfdId();
  /// <summary>
  /// Represents a 3-tuple with protocol, server ip and server port for UL/DL
  /// application traffic.
  /// </summary>
  std::vector<std::string> &getFlowDescriptions();
  void setFlowDescriptions(std::vector<std::string> const &value);
  bool flowDescriptionsIsSet() const;
  void unsetFlowDescriptions();
  /// <summary>
  /// Indicates a URL or a regular expression which is used to match the
  /// significant parts of the URL.
  /// </summary>
  std::vector<std::string> &getUrls();
  void setUrls(std::vector<std::string> const &value);
  bool urlsIsSet() const;
  void unsetUrls();
  /// <summary>
  /// Indicates an FQDN or a regular expression as a domain name matching
  /// criteria.
  /// </summary>
  std::vector<std::string> &getDomainNames();
  void setDomainNames(std::vector<std::string> const &value);
  bool domainNamesIsSet() const;
  void unsetDomainNames();
  /// <summary>
  ///
  /// </summary>
  DomainNameProtocol getDnProtocol() const;
  void setDnProtocol(DomainNameProtocol const &value);
  bool dnProtocolIsSet() const;
  void unsetDnProtocol();

  friend void to_json(nlohmann::json &j, const PfdContent &o);
  friend void from_json(const nlohmann::json &j, PfdContent &o);

protected:
  std::string m_PfdId;
  bool m_PfdIdIsSet;
  std::vector<std::string> m_FlowDescriptions;
  bool m_FlowDescriptionsIsSet;
  std::vector<std::string> m_Urls;
  bool m_UrlsIsSet;
  std::vector<std::string> m_DomainNames;
  bool m_DomainNamesIsSet;
  DomainNameProtocol m_DnProtocol;
  bool m_DnProtocolIsSet;
};

} // namespace model
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* PfdContent_H_ */
