/**
 * Nudr_DataRepository API OpenAPI file
 * Unified Data Repository Service. © 2020, 3GPP Organizational Partners (ARIB,
 * ATIS, CCSA, ETSI, TSDSI, TTA, TTC). All rights reserved.
 *
 * The version of the OpenAPI document: 2.1.2
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator
 * (https://openapi-generator.tech). https://openapi-generator.tech Do not edit
 * the class manually.
 */
/*
 * UsageMonData.h
 *
 * Contains remain allowed usage data for a subscriber.
 */

#ifndef UsageMonData_H_
#define UsageMonData_H_

#include "TimePeriod.h"
#include "UsageMonDataScope.h"
#include "UsageMonLevel.h"
#include "UsageThreshold.h"
#include <map>
#include <nlohmann/json.hpp>
#include <string>
#include <vector>

namespace org {
namespace openapitools {
namespace server {
namespace model {

/// <summary>
/// Contains remain allowed usage data for a subscriber.
/// </summary>
class UsageMonData {
public:
  UsageMonData();
  virtual ~UsageMonData();

  void validate();

  /////////////////////////////////////////////
  /// UsageMonData members

  /// <summary>
  ///
  /// </summary>
  std::string getLimitId() const;
  void setLimitId(std::string const &value);
  /// <summary>
  ///
  /// </summary>
  std::map<std::string, UsageMonDataScope> &getScopes();
  void setScopes(std::map<std::string, UsageMonDataScope> const &value);
  bool scopesIsSet() const;
  void unsetScopes();
  /// <summary>
  ///
  /// </summary>
  UsageMonLevel getUmLevel() const;
  void setUmLevel(UsageMonLevel const &value);
  bool umLevelIsSet() const;
  void unsetUmLevel();
  /// <summary>
  ///
  /// </summary>
  UsageThreshold getAllowedUsage() const;
  void setAllowedUsage(UsageThreshold const &value);
  bool allowedUsageIsSet() const;
  void unsetAllowedUsage();
  /// <summary>
  ///
  /// </summary>
  TimePeriod getResetTime() const;
  void setResetTime(TimePeriod const &value);
  bool resetTimeIsSet() const;
  void unsetResetTime();
  /// <summary>
  ///
  /// </summary>
  std::string getSuppFeat() const;
  void setSuppFeat(std::string const &value);
  bool suppFeatIsSet() const;
  void unsetSuppFeat();

  friend void to_json(nlohmann::json &j, const UsageMonData &o);
  friend void from_json(const nlohmann::json &j, UsageMonData &o);

protected:
  std::string m_LimitId;

  std::map<std::string, UsageMonDataScope> m_Scopes;
  bool m_ScopesIsSet;
  UsageMonLevel m_UmLevel;
  bool m_UmLevelIsSet;
  UsageThreshold m_AllowedUsage;
  bool m_AllowedUsageIsSet;
  TimePeriod m_ResetTime;
  bool m_ResetTimeIsSet;
  std::string m_SuppFeat;
  bool m_SuppFeatIsSet;
};

} // namespace model
} // namespace server
} // namespace openapitools
} // namespace org

#endif /* UsageMonData_H_ */
